# std::negate

From cppreference.com
< cpp‎ | utility‎ | functional

Defined in header `<functional>` |  |
template< class T > struct negate; |  | (until C++14)
template< class T = void > struct negate; |  | (since C++14)

Function object for performing negation. Effectively calls operator- on an instance of type `T`.

### Specializations

The standard library provides a specialization of `std::negate` when `T` is not specified, which leaves the parameter types and return type to be deduced.

negate<void> | function object implementing -x deducing argument and return types (class template specialization)

(since C++14)

### Member types

Type | Definition
`result_type`(deprecated in C++17) | `T`
`argument_type`(deprecated in C++17) | `T`

### Member functions

operator() | returns the negation of the argument (public member function)

## std::negate::operator()

T operator()( const T& arg ) const; |  | (until C++14)
constexpr T operator()( const T& arg ) const; |  | (since C++14)

Returns the negation of `arg`.

### Parameters

arg | - | value to compute negation of

### Return value

The result of -arg.

### Exceptions

(none)

### Possible implementation

    constexpr T operator()(const T &arg) const
    {
        return -arg;
    }

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/utility/functional/negate&oldid=83698"